#include <stdio.h>

typedef union {

  struct {
  float x;
  float y;
  float z;
  };

  float e[3];
    
} vec3;

vec3 vec3_plus(vec3 a, vec3 b) {
  vec3 ret = {a.x + b.x, a.y + b.y, a.z + b.z};
  return ret;
}

vec3 vec3_minus(vec3 a, vec3 b) {
  vec3 ret = {a.x - b.x, a.y - b.y, a.z - b.z};
  return ret;
}

vec3 vec3_times(vec3 a, vec3 b) {
  vec3 ret = {a.x * b.x, a.y * b.y, a.z * b.z};
  return ret;
}

vec3 vec3_div(vec3 a, vec3 b) {
  vec3 ret = {a.x / b.x, a.y / b.y, a.z / b.z};
  return ret;
}

vec3 vec3_timesf(vec3 a, float b) {
  vec3 ret = {a.x * b, a.y * b, a.z * b};
  return ret;
}

vec3 vec3_divf(vec3 a, float b) {
  vec3 ret = {a.x / b, a.y / b, a.z / b};
  return ret;
}

vec3 vec3_dot(vec3 a, vec3 b) {
  return a.x * b.x + a.y * b.y + a.z * b.z;
}

//@todo: continue here
/* vec3 vec3_cross(vec3 a, vec3 b) { */
/*   vec3 ret = {   a.y * b.z - a.z * b.y, */
/* 		 -(a.x * b.z - (), */
		 
/*   } */
/* } */

int main() {

  FILE *out = fopen("test.ppm","w");  
  fprintf(out, "P3\n");

  int nx = 800;
  int ny = 600;

  fprintf(out, "%i %i\n255\n", nx, ny);

  for (int row = 0; row < ny; row += 1) {
    for (int column = 0; column < nx; column += 1) {
      float r = (float) row / (float) ny;
      float g = (float) column / (float) nx;
      float b = 0.2;

      int ir = 255.9 * r;
      int ig = 255.9 * g;
      int ib = 255.9 * b;
      
      fprintf(out, "%i %i %i\n", ir, ig, ib);
    }
  }
  fclose(out);

  return 0;
}
